--------------------------------------------------------------------------------
-- Code developed by Generis Technology Limited
--
-- Product Name: B-Smart
--
-- Component Name: Meter Asset Manager
--
-- Description: Script to apply MDD change 18/010
--
-- Amendment History:                   Date        Author            Vers
-- ------------------                   ---------   -------           -----
-- B-Smart Initial Release              30-DEC-99   Generis           18.2
--------------------------------------------------------------------------------
--
-- SET SERVEROUTPUT ON SIZE 1000000
SET VERIFY OFF
--
SET SCAN OFF
--
PROMPT
PROMPT Script to apply MDD change 18/010
PROMPT
PROMPT Version 18.2
PROMPT
--
PROMPT
PROMPT Apply add HGN as PGT (and iGT) (MDD 18/010)
PROMPT
--
DECLARE

  invalid_column      EXCEPTION;
  is_snapshot         EXCEPTION;
  row_exists          EXCEPTION;
  fk_violated         EXCEPTION;
  PRAGMA EXCEPTION_INIT(invalid_column, -904);
  PRAGMA EXCEPTION_INIT(is_snapshot, -1732);
  PRAGMA EXCEPTION_INIT(row_exists, -1);
  PRAGMA EXCEPTION_INIT(fk_violated, -2292);

  CURSOR C_SPA_ACTIVE IS
    SELECT PARAM_VALUE FROM PROGRAM_PARAMETERS WHERE PARAM_NAME = 'SPA_ACTIVE';
  L_SPA_ACTIVE    VARCHAR2(1);

BEGIN

  EXECUTE IMMEDIATE 'INSERT INTO MARKET_PARTICIPANT (MARKET_PARTICIPANT_CODE,MARKET_PARTICIPANT_NAME,
                     CREATED_USER_ID,CREATED_DATE,MARKET_PARTICIPANT_ABBR_NAME)
                     VALUES (''HGN'',''Harlaxton Gas Networks Ltd'',''MDD_18_010'',SYSDATE,''HGN'')';

  EXECUTE IMMEDIATE 'INSERT INTO ADDRESS (ADDRESS_ID,BUILDING_NUMBER,BUILDING_NAME,BUILDING_NAME_SUB,
                     ADDRESS_1,ADDRESS_2,ADDRESS_3,ADDRESS_4,POSTCODE_OUTCODE,POSTCODE_INCODE,
                     CREATED_USER_ID,CREATED_MARKET_PARTICIPANT,CREATED_DATE)
                     VALUES (ADDRESS_ID_SEQ.NEXTVAL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,''X9'',''9XX'',
                     ''MDD_18_010'',''BSMART'',SYSDATE)';

  EXECUTE IMMEDIATE 'INSERT INTO MARKET_PARTICIPANT_IN_ROLE (MARKET_PARTICIPANT_CODE,MARKET_PARTICIPANT_ROLE_CODE,
                     EFFECTIVE_FROM_DATE,EFFECTIVE_TO_DATE,MARKET_PARTICIPANT_ROLE_NAME,ADDRESS_ID,
                     REGISTRATION_NUMBER,REGISTRATION_BODY,MARKET_PARTICIPANT_ROLE_ID,
                     MARKET_PARTICIPANT_ROLE_PORT,ORGANISATION_ID,CREATED_USER_ID,CREATED_DATE)
                     VALUES (''HGN'',''PGT'',TO_DATE(''01012000000000'',''DDMMYYYYHH24MISS''),NULL,
                     ''Harlaxton Gas Networks Ltd (PGT)'',ADDRESS_ID_SEQ.CURRVAL,NULL,NULL,NULL,NULL,'''',
                     ''MDD_18_010'',SYSDATE)';

  EXECUTE IMMEDIATE 'INSERT INTO MARKET_PARTICIPANT_IN_ROLE (MARKET_PARTICIPANT_CODE,MARKET_PARTICIPANT_ROLE_CODE,
                     EFFECTIVE_FROM_DATE,EFFECTIVE_TO_DATE,MARKET_PARTICIPANT_ROLE_NAME,ADDRESS_ID,
                     REGISTRATION_NUMBER,REGISTRATION_BODY,MARKET_PARTICIPANT_ROLE_ID,
                     MARKET_PARTICIPANT_ROLE_PORT,ORGANISATION_ID,CREATED_USER_ID,CREATED_DATE)
                     VALUES (''HGN'',''IGT'',TO_DATE(''01012000000000'',''DDMMYYYYHH24MISS''),NULL,
                     ''Harlaxton Gas Networks Ltd (IGT)'',ADDRESS_ID_SEQ.CURRVAL,NULL,NULL,NULL,NULL,'''',
                     ''MDD_18_010'',SYSDATE)';

  OPEN C_SPA_ACTIVE;
  FETCH C_SPA_ACTIVE INTO L_SPA_ACTIVE;
  CLOSE C_SPA_ACTIVE;
  IF NVL(L_SPA_ACTIVE,'N') = 'Y' THEN
    EXECUTE IMMEDIATE 'INSERT INTO CROSS_REFERENCE (ATTRIBUTE_NAME,SYSTEM_CODE,CODE_DESCRIPTION,USER_AMENDABLE,
                                                    CREATED_USER_ID,CREATED_MARKET_PARTICIPANT,CREATED_DATE)
                       SELECT ''SPA_SYSTEM_GT'',''HGN'',''Harlaxton Gas Networks Ltd'',''N'',
                              ''MDD_18_010'',''BSMART'',SYSDATE FROM DUAL
                       WHERE NOT EXISTS (SELECT NULL FROM CROSS_REFERENCE
                                          WHERE ATTRIBUTE_NAME = ''SPA_SYSTEM_GT'' AND SYSTEM_CODE = ''HGN'')';
  END IF;

  EXECUTE IMMEDIATE 'INSERT INTO MARKET_PARTICIPANT_IN_ROLE (MARKET_PARTICIPANT_CODE,MARKET_PARTICIPANT_ROLE_CODE,
                     EFFECTIVE_FROM_DATE,EFFECTIVE_TO_DATE,MARKET_PARTICIPANT_ROLE_NAME,ADDRESS_ID,
                     REGISTRATION_NUMBER,REGISTRATION_BODY,MARKET_PARTICIPANT_ROLE_ID,
                     MARKET_PARTICIPANT_ROLE_PORT,ORGANISATION_ID,CREATED_USER_ID,CREATED_DATE)
                     VALUES (''HGN'',''NWO'',TO_DATE(''01012000000000'',''DDMMYYYYHH24MISS''),NULL,
                     ''Harlaxton Gas Networks Ltd (NWO)'',ADDRESS_ID_SEQ.CURRVAL,NULL,NULL,NULL,NULL,'''',
                     ''MDD_18_010'',SYSDATE)';

EXCEPTION
  WHEN is_snapshot OR invalid_column THEN
    NULL;
END;
/
--
SET SCAN ON
--
COMMIT
/
--
SET VERIFY ON
--
