--------------------------------------------------------------------------------
-- Code developed by Generis Technology Limited
--
-- Product Name: B-Smart
--
-- Component Name: Meter Asset Manager
--
-- Description: Script to regress MDD change 18/010
--
-- Amendment History:                   Date        Author            Vers
-- ------------------                   ---------   -------           -----
-- B-Smart Initial Release              30-DEC-99   Generis           18.2
--------------------------------------------------------------------------------
--
-- SET SERVEROUTPUT ON SIZE 1000000
SET VERIFY OFF
--
SET SCAN OFF
--
PROMPT
PROMPT Script to regress MDD change 18/010
PROMPT
PROMPT Version 18.2
PROMPT
--
PROMPT
PROMPT Regress add HGN as PGT (and iGT) (MDD 18/010)
PROMPT
--
DECLARE

  invalid_column      EXCEPTION;
  is_snapshot         EXCEPTION;
  row_exists          EXCEPTION;
  fk_violated         EXCEPTION;
  PRAGMA EXCEPTION_INIT(invalid_column, -904);
  PRAGMA EXCEPTION_INIT(is_snapshot, -1732);
  PRAGMA EXCEPTION_INIT(row_exists, -1);
  PRAGMA EXCEPTION_INIT(fk_violated, -2292);

  CURSOR C_SPA_ACTIVE IS
    SELECT PARAM_VALUE FROM PROGRAM_PARAMETERS WHERE PARAM_NAME = 'SPA_ACTIVE';
  L_SPA_ACTIVE    VARCHAR2(1);

BEGIN

  EXECUTE IMMEDIATE 'DELETE FROM MARKET_PARTICIPANT_IN_ROLE 
                      WHERE MARKET_PARTICIPANT_CODE = ''HGN''
                        AND MARKET_PARTICIPANT_ROLE_CODE = ''PGT''';

  EXECUTE IMMEDIATE 'DELETE FROM MARKET_PARTICIPANT_IN_ROLE 
                      WHERE MARKET_PARTICIPANT_CODE = ''HGN''
                        AND MARKET_PARTICIPANT_ROLE_CODE = ''IGT''';

  OPEN C_SPA_ACTIVE;
  FETCH C_SPA_ACTIVE INTO L_SPA_ACTIVE;
  CLOSE C_SPA_ACTIVE;
  IF NVL(L_SPA_ACTIVE,'N') = 'Y' THEN
    EXECUTE IMMEDIATE 'DELETE FROM CROSS_REFERENCE 
                        WHERE ATTRIBUTE_NAME = ''SPA_SYSTEM_GT''
                          AND SYSTEM_CODE = ''HGN''';

  END IF;

  EXECUTE IMMEDIATE 'DELETE FROM MARKET_PARTICIPANT_IN_ROLE 
                      WHERE MARKET_PARTICIPANT_CODE = ''HGN''
                        AND MARKET_PARTICIPANT_ROLE_CODE = ''NWO''';

  EXECUTE IMMEDIATE 'DELETE FROM MARKET_PARTICIPANT 
                      WHERE MARKET_PARTICIPANT_CODE = ''HGN''';

EXCEPTION
  WHEN is_snapshot OR invalid_column THEN
    NULL;
END;
/
--
SET SCAN ON
--
COMMIT
/
--
SET VERIFY ON
--
